#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------
#include <Array.au3>

Global $__GEng_Images[1] = [0]

; ==============================================================
#Region - Class - Image
; ==============================================================
Func _GEng_Image($sPath)
	Local $hImg = _GDIPlus_ImageLoadFromFile($sPath)
	If @error Then Return SetError(1, 0, 0)
	; ---
	_ArrayAdd($__GEng_Images, $hImg)
	$__GEng_Images[0] += 1
	; ---
	Local $w = _GDIPlus_ImageGetWidth($hImg)
	Local $h = _GDIPlus_ImageGetHeight($hImg)
	; ---
	$obj = _AutoItObject_Class()
	With $obj
		.AddProperty("imgIndex", $ELSCOPE_READONLY, $__GEng_Images[0])
		.AddProperty("width", $ELSCOPE_READONLY, $w)
		.AddProperty("height", $ELSCOPE_READONLY, $h)
		.AddProperty("path", $ELSCOPE_READONLY, $sPath)
		; ---
		.AddDestructor("__GEng_cImage_Destructor")
	EndWith
	; ---
	Return $obj.object
EndFunc

; ==============================================================
; ### Methods
; ==============================================================
; Not a method, it's a function
Func _GEng_oImg2hImg($oImg)
	Local $i = $oImg.imgIndex
	Return $__GEng_Images[$i]
EndFunc

; ==============================================================
; ### Destructor
; ==============================================================
Func __GEng_cImage_Destructor($oSelf)
	Local $imgIndex = $oSelf.imgIndex
	ConsoleWrite("Destructing: " & $oSelf.path & @CRLF)
	_GDIPlus_ImageDispose($__GEng_Images[$imgIndex])
EndFunc

#EndRegion
; ==============================================================


