#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

Global $__GEng_SpritesArray[1] = [0]

; ==============================================================
#Region - Class Sprite
; ==============================================================
Func _GEng_Sprite($oImg = 0, $x = 0, $y = 0)
	$obj = _AutoItObject_Class()
	With $obj
		.AddProperty("posX", $ELSCOPE_READONLY, $x)
		.AddProperty("posY", $ELSCOPE_READONLY, $y)
		.AddProperty("width", $ELSCOPE_READONLY, 0)
		.AddProperty("height", $ELSCOPE_READONLY, 0)
		.AddProperty("originX", $ELSCOPE_READONLY, 0)
		.AddProperty("originY", $ELSCOPE_READONLY, 0)
		.AddProperty("oImage", $ELSCOPE_READONLY, $oImg)
		; ---
		.AddMethod("setPos", "__GEng_cSprite_setPos")
		.AddMethod("setSize", "__GEng_cSprite_setSize")
		.AddMethod("setOrigin", "__GEng_cSprite_setOrigin")
		.AddMethod("setOriginEx", "__GEng_cSprite_setOriginEx")
		.AddMethod("setImage", "__GEng_cSprite_setImage")
		.AddMethod("Draw", "__GEng_cSprite_Draw")
		; ---
		.AddDestructor("__GEng_cSprite_Destructor")
	EndWith
	; ---
	Local $ret = $obj.object
	_ArrayAdd($__GEng_SpritesArray, $ret)
	$__GEng_SpritesArray[0] += 1
	; ---
	If $oImg <> 0 Then $ret.setSize()
	; ---	
	Return $ret
EndFunc

; ==============================================================
; ### Methods
; ==============================================================
Func __GEng_cSprite_setPos($oSelf, $x, $y)
	$oSelf.posX = $x
	$oSelf.posY = $y
	Return 1
EndFunc

Func __GEng_cSprite_setSize($oSelf, $w = Default, $h = Default)
	Local $img = $oSelf.oImage
	; ---
	If $w = Default Then
		If $img <> 0 Then
			$w = $img.width
		Else
			$w = 0
		EndIf
	EndIf
	If $h = Default Then
		If $img <> 0 Then
			$h = $img.height
		Else
			$h = 0
		EndIf
	EndIf
	; ---
	If $w <> Default Then $oSelf.width = $w
	If $h <> Default Then $oSelf.height = $h
	Return 1
EndFunc

Func __GEng_cSprite_setOrigin($oSelf, $x = Default, $y = Default)
	If $x <> Default Then $oSelf.originX = $x
	If $y <> Default Then $oSelf.originY = $y
	Return 1
EndFunc

Func __GEng_cSprite_setOriginEx($oSelf, $var)
	Local $img = $oSelf.oImage
	If $img = 0 Then Return SetError(1, 0, 0)
	; ---
	Local $imgX = $img.width
	Local $imgY = $img.height
	; ---
	Local $x = Default, $y = Default
	Switch $var
		Case "middle"
			$x = $imgX / 2
			$y = $imgY / 2
		Case "topLeft"
			$x = 0
			$y = 0
		Case "topRight"
			$x = $imgX
			$y = 0
		Case "botLeft"
			$x = $imgY
			$y = 0
		Case "botRight"
			$x = $imgX
			$y = $imgY
	EndSwitch
	; ---
	Return $oSelf.setOrigin($x, $y)
EndFunc

Func __GEng_cSprite_setImage($oSelf, $oImg = 0)
	$oSelf.oImage = $oImg
	$oSelf.setSize()
	Return 1
EndFunc

Func __GEng_cSprite_Draw($oSelf)
	If $oSelf.oImage = 0 Then Return SetError(1, 0, 0)
	; ---
	Local $width = $oSelf.width
	Local $height = $oSelf.height
	Local $drawPosX = $oSelf.posX - $oSelf.originX
	Local $drawPosY = $oSelf.posY - $oSelf.originY
	Local $hImg = _GEng_oImg2hImg($oSelf.oImage)
	Local $hGraphic = $__GEng_WindowArray[1]
	; ---
	Return _GDIPlus_GraphicsDrawImageRect($hGraphic, $hImg, $drawPosX, $drawPosY, $width, $height)
EndFunc

; ==============================================================
; ### Destrctor
; ==============================================================
Func __GEng_cSprite_Destructor($oSelf)
	ConsoleWrite("Sprite Destructed!" & @CRLF)
EndFunc

#EndRegion
; ==============================================================
