#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

; ==============================================================
#Region - Class Window
; ==============================================================
Global $__GEng_WindowArray[4] = [0,0,0,0] ; Contient hGui, hGraphic, hBitmap, hBuffer

Func _GEng_Window($sTitle, $iW, $iH, $iX = -1, $iY = -1, $iStyle = -1, $iExtStyle = -1)
	Local $hGui = GuiCreate($sTitle, $iW, $iH, $iX, $iY, $iStyle, $iExtStyle)
	If @error Then Return SetError(@error, 0, 0)
	; ---
	_GDIPlus_Startup()
	Local $hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)
	Local $hBitmap = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGraphic)
	Local $hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	; ---
	_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)
	; ---
	$__GEng_WindowArray[0] = $hGui
	$__GEng_WindowArray[1] = $hGraphic
	$__GEng_WindowArray[2] = $hBitmap
	$__GEng_WindowArray[3] = $hBuffer
	; ---
	Local $obj = _AutoItObject_Class()
	With $obj
		.AddProperty("width", $ELSCOPE_READONLY, $iW)
		.AddProperty("height", $ELSCOPE_READONLY, $iH)
		; ---
		; Drawing
		.AddMethod("DrawStart", "__GEng_cWindow_DrawStart")
		.AddMethod("DrawEnd", "__GEng_cWindow_DrawEnd")
		; ---
		.AddDestructor("__GEng_cWindow_Destructor")
	EndWith
	; ---
	GuiSetState(@SW_SHOW, $hGui)
	$__GEng_Window = $obj.object
	Return $__GEng_Window
EndFunc

; ==============================================================
; ### Methods
; ==============================================================
; Drawing methods In GEng_Drawing.au3

; ==============================================================
; ### Destructor
; ==============================================================
Func __GEng_cWindow_Destructor($oSelf)
	Local $hGui, $hBuffer, $hBitmap, $hGraphic
	$hGraphic = $__GEng_WindowArray[1]
	$hBitmap = $__GEng_WindowArray[2]
	$hBuffer = $__GEng_WindowArray[3]
	$hGui = $__GEng_WindowArray[0]
	; ---
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_Shutdown()
	GuiDelete($hGui)
	Return 1
EndFunc

#EndRegion
; ==============================================================
